%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b10_s34DB.erl
%--
%-- AUTHORS:     Tamarit
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of the program solving the common
%--              divisors problem implemented in the file solution.erl available at: 
%--              https://github.com/tamarit/hackerrank/tree/master/common-divisors
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program receives a list with pairs of integers and compute the number of common 
%-- divisors of each pair. The program returns a list with the number of common divisors
%-- in the same order as the input pairs.
%--
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench10.erl
%-- SLICING CRITERION: (34,DB)/(Node 41)
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(b10_s34DB).
-export([main/1]).

main(L) ->
    _ = calculate(L).

calculate(List) ->
    calculate(List, undef).

calculate([{_,B}|T], _) ->
    DB = divs(B),
    calculate(T, undef).

divs(0) ->
    [];
divs(1) ->
    [1];
divs(N) ->
    [1,N] ++ divisors(2, N, math:sqrt(N)).

divisors(K, _, Q) when K > Q ->
    [];
divisors(K, N, Q) when N rem K =/= 0 ->
    divisors(K + 1, N, Q);
divisors(K, N, Q) when K * K == N ->
    [K] ++ divisors(undef, undef, Q);
divisors(K, N, Q) ->
    [K,N div K] ++ divisors(K + 1, N, Q).
