%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b11_s28C.erl
%--
%-- AUTHORS: 	 Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of a program specially developed 
%--				 to test non-called funtions.
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- This benchmark consists in a function that receives two lists as inputs and calls
%-- another one named fl with a conditional structure. There is also another function 
%-- gl that is not called by lists or fl.
%-- 
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench11.erl
%-- SLICING CRITERION: (28,C)/(Node 8)
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------

-module(b11_s28C).
-export([lists/2]).

lists(A,B) -> 
	C=fl(A,B).

fl([H1|_],[H2|T2]) ->
	if	H1 >= 3 -> 
			H2;
		true -> 
			[H|_]=T2,
			H1-H  
	end.
