%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b12_s92A.erl
%--
%-- AUTHORS:     Tamarit
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of the program solving the common
%--              divisors problem implemented in the file solution.erl available at: 
%--              https://github.com/tamarit/hackerrank/tree/master/common-divisors
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program receives a list with pairs of integers and compute the number of common 
%-- divisors of each pair. The program returns a list with the number of common divisors
%-- in the same order as the input pairs.
%--
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench12.erl
%-- SLICING CRITERION: (92,A)/(Node 348)    
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------

-module(b12_s92A).
-export([main/3]).
 
main(_,B,_) ->
    
    BT = to_ternary(B),
    
    _ = funundef(undef,sub(BT,undef)).
    
to_ternary(N) when N > 0 ->
    to_ternary(N,[]);
to_ternary(N) ->
    neg(to_ternary(-N)).
 
to_ternary(0,Acc) ->
    Acc;
to_ternary(N,Acc) when N rem 3 == 0 ->
    to_ternary(N div 3, [0|Acc]);
to_ternary(N,Acc) when N rem 3 == 1 ->
    to_ternary(N div 3, [1|Acc]);
to_ternary(N,Acc) ->
    _ = to_ternary((N+1) div 3, [-1|Acc]).

neg(T) -> [ -H || H <- T].
 
sub(A,_) -> 
    funundef(A,undef).
 
funundef(_,_) -> undef.
