%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b13_s38NewI.erl
%-- 
%-- AUTHORS:     Susan Horwitz
%-- DATE:        1990         
%-- PUBLISHED:   This is the (only) minimal slice of the program proposed by Susan Horwitz
%-- 			 to ilustrate the limitations of interprocedural slicing using dependence 
%--				 graphs. ACM Transactions on Programming Languages and Systems
%--              Volume 12 Issue 1, Jan. 1990 Pages 26-60 
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program proposed by Susan Horwitz was designed to ilustrate the problem of the 
%-- Weiser's slicing algorithm in interprocedural slicing. The program makes a recursive 
%-- call to add up the first 11 naturals.
%--
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench13.erl
%-- SLICING CRITERION: (38,NewI)/(Node 41)   
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(b13_s38NewI).
-export([main/0]).

main() -> 
  I = 1,
  _ = while(undef,I,11).

while(_,I,Top) ->
  if Top /= 0 ->
        NewI = increment(I),
        while(undef,NewI,Top-1)
  end.

add(A,B) -> A+B.
increment(A) -> add(A,1).

