%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b14_s44V.erl
%--
%-- AUTHORS:     Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of a program specially developed 
%--              to test challenging slicing problems
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program plans a set of difficult slicing problems like unreachable clauses in case
%-- statements or never called function clauses. It receives two inputs of any nature and
%-- processes them with a suit of case statements and function calls to obtain a final 
%-- result.
%--
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench6.erl
%-- SLICING CRITERION: (44,V)/(Node 56)    
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(b14_s44V).
-export([main/2]).

main(_, _) ->

    V = f(undef) + h(2) + h(undef).

f(_) ->
    7.

h(X) ->
    case X of
        2 ->
            j({2,undef});
        _ ->
            k([4|undef])
    end.

j(A) ->
    {X,_} = A,
    X.

k(B) ->
    [H|_] = B,
    H.
