%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b14_s45W.erl
%--
%-- AUTHORS:     Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of a program specially developed 
%--              to test challenging slicing problems
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program plans a set of difficult slicing problems like unreachable clauses in case
%-- statements or never called function clauses. It receives two inputs of any nature and
%-- processes them with a suit of case statements and function calls to obtain a final 
%-- result.
%-- 
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench6.erl
%-- SLICING CRITERION: (45,W)/(Node 72)    
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(b14_s45W).
-export([main/2]).

main(X, _) ->
    W = g([undef,undef,{X,undef}|undef]).

g(X) ->
    [_,_,{R,_}|_] = X,
    case R of
        [1,3] ->
            21;
        [A,B] ->
            A * B / 9;
        T ->
            T
    end.