%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b14_s46Z.erl
%--
%-- AUTHORS:     Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of a program specially developed 
%--              to test challenging slicing problems
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program plans a set of difficult slicing problems like unreachable clauses in case
%-- statements or never called function clauses. It receives two inputs of any nature and
%-- processes them with a suit of case statements and function calls to obtain a final 
%-- result.
%-- 
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench6.erl
%-- SLICING CRITERION: (46,Z)/(Node 88)    
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(b14_s46Z).
-export([main/2]).

main(X, _) ->
    Z = case X of
            terminate ->
                "the end";
            {A,B} ->
                {[A + B,B - A],3};
            _ ->
                {20 * 3,8}
        end,
    _ = {Z,undef,undef}.
    