%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b16_s58C.erl
%--
%-- AUTHORS:     K.B. Gallagher and J.R. Lyle
%-- DATE:        1991         
%-- PUBLISHED:   This is the (only) minimal slice of the program solving the word count
%--              problem implemented in Erlang. The original problem is available at:
%-- 			 Using program slicing in software maintenance,
%--              IEEE Transactions on Software Engineering, 
%--              vol. 17, no. 8, 1991.
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The word count program, computes the number of lines, words, and characters in an 
%-- input text file.
%--
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench16.erl
%-- SLICING CRITERION: (58,C)  
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(b16_s58C).
-export([word_count/1]).

-spec word_count(string()) -> any().
word_count(Text) ->
    word_count(Text, undef, undef, undef, undef).

word_count([C|Text], _, _, _, _) ->
    _ = case isLetter(C) of
            _ ->
                undef
        end,
    word_count(Text, undef, undef, undef, undef).

isLetter(C) ->
    funundef(undef, [C|undef]).

funundef(_, _) ->
    undef.