%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b2_s40D.erl
%--
%-- AUTHORS:     Anonymous
%-- DATE:        2016 
%-- PUBLISHED:   This is the (only) possible minimal slice of a program specially 
%--              developed to test higher order functions and anonymous functions.
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The benchmark receives two input parameters and executes a call to a function using fun 
%-- expressions. These expressions are stored in variables and are called later.
%-- 
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench2.erl
%-- SLICING CRITERION: (40,D)/(Node 30)
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------

-module(b2_s40D).
-export([main/2]).
main(A,B)->
	D=h(fun g/2,A,B).

g(X,Y) ->
	(fun(A,B) -> A+B end)(X,Y).  

h(F,A,B) ->  
	F(A,B).
