%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b4_s32Abb.erl
%--
%-- AUTHORS:     Anonymous
%-- DATE:        2016 
%-- PUBLISHED:   This is the (only) possible minimal slice of a program specially 
%-- 			 developed to test list comprehensions and blocks. 
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program receives a list of chemical elements with their abbreviation and their 
%-- melt temperature in the format {Element,Abbreviation,Melting_Temp} and a temperature.
%-- It returns a list with the elements whose melt temperature is greater than the 
%-- given temperature, the format of each object is {Element,Melting_Temp}. 
%-- It also returns a list with the abbreviations of the selected elements when their
%-- length is one character.
%-- 
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench4.erl
%-- SLICING CRITERION: (32,Abb)/(Node 15)
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------

-module(b4_s32Abb).
-export([main/2]).

main(Elements,Temp) ->
	Res = templessthan(Temp,Elements),
	Abb = abbreviation(Elements,Res).

templessthan(Temp,Elem) -> 
	[begin
		{Name,undef} 
	end
	||{Name,_,T} <- Elem, T > Temp].

abbreviation(Elements,List) -> 
	[Abb||{RN,_} <- List, {Name,Abb,_} <- Elements, RN == Name andalso length(atom_to_list(Abb)) == 1].
