%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b6_s36D.erl
%--
%-- AUTHORS: 	 Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of a program specially developed 
%--              to test the detection of unreachable clauses in case conditional 
%--              structure and never matching clauses in functions. 
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The benchmark consists in a function that receives two tuples as input. It calls 
%-- another two functions that contain a case statement with unreachable clauses. One of 
%-- this functions also make a call to another function with unreachable and unmatcheable 
%-- clauses.
%-- 
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench6.erl
%-- SLICING CRITERION: (36,D)/(Node 15)
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------

-module(b6_s36D).
-export([tuples/2]).

tuples(A,B) ->
	D=ht(B,A).

ht({_,_,Z},{A,B})-> 
	case undef of
		_ -> A+Z*B
	end.
