%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b8_s29Deposits.erl
%--
%-- AUTHORS: 	 Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of a program specially developed 
%--				 to test tail recursion and guards.
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program receives a list of movements in a saving account with the format 
%-- {Movement, Amount, User} and a user Who. It returns two lists, one list
%-- for user's deposits greater than 300 and another one for the withdraws 
%-- greater than 100.
%-- 
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench8.erl
%-- SLICING CRITERION: (29,Deposits)/(Node 9)
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------

-module(b8_s29Deposits).
-export([main/2]).

main(Account,Who) -> 
	
	{Deposits, _} = recount(Who, Account).

recount(Person, List) -> tailrecount(Person,List,[],undef).

tailrecount(_,[],LDeposits, _) -> {LDeposits,undef};
tailrecount(Person,[H|T],LDeposits,_) -> 
	case H of
		{Mov, Amount, Person} when Mov == deposit andalso Amount >300 ->
			tailrecount(Person,T,[H|LDeposits],undef);
		_ -> tailrecount(Person,T,LDeposits,undef)
	end.

