%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- b9_s59A.erl
%--
%-- AUTHORS: 	 Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   This is the (only) minimal slice of a program  specially developed 
%--				 to test the define and spec expressions.
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program receives a number and a state to switch the stove as inputs. If the state 
%-- is ON and the number is greater than twenty, the program returns a success message,
%-- if it is ON and the number is less than or equal to twenty the program returns an 
%-- error message. The OFF input state always provides a success message.
%--
%-- ORIGINAL PROGRAM: Available at: 
%--    http://www.dsic.upv.es/~jsilva/slicing/bencher/programs/bench9.erl
%-- SLICING CRITERION: (59,A)/(Node 65)
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------

-module(b9_s59A).
-export([main/2]).
-define(ERROR,failure).
-define(ON,enable).

light(N,L) -> if N > 20 andalso L==?ON -> {undef, "Success switching ON"};
				 N =< 20 andalso L==?ON -> {undef, ?ERROR};
  			     true   -> {undef, "Success switching OFF"}
			  end.

stove(P,L) -> if L == ?ON -> {_,Reply} = light(P,L);
				 true -> {_,Reply} = light(undef,undef)
			  end, Reply.

main(N,State) when (N > -480 andalso N =< 520) andalso (State == ?ON orelse State == ?OFF) -> 
	A=stove(N,State).
